## kdevelop 5.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(KDevelop VERSION 5.5.0)

# KDevelop SOVERSION
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVELOP_SOVERSION 55)

# plugin version as used e.g. in plugin installation path
set(KDEV_PLUGIN_VERSION 33)

# we need some parts of the ECM CMake helpers
find_package (ECM 5.28.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${KDevelop_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE) # needs to be first, as set policies influence following macros

include(ECMOptionalAddSubdirectory)
include(ECMInstallIcons)
include(ECMAddAppIcon)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMMarkNonGuiExecutable)
include(ECMGenerateHeaders)
include(ECMQtDeclareLoggingCategory)

include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(FeatureSummary)
include(WriteBasicConfigVersionFile)
include(CheckFunctionExists)

include(KDevelopMacrosInternal)

if(POLICY CMP0071)
  # CMake 3.10 generates warnings when projects combine AUTOMOC with qt5_wrap_ui() or qt5_add_resources()
  # Avoid that by setting this policy (cf. https://bugreports.qt.io/browse/QTBUG-63442)
  # Note: Once we depend on a Qt which has this fix (likely Qt 5.9.4+), remove this
  cmake_policy(SET CMP0071 OLD)
endif()

set(QT_MIN_VERSION "5.7.0")
find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Widgets Concurrent Quick QuickWidgets)
if(BUILD_TESTING)
  find_package(Qt5Test ${QT_MIN_VERSION} CONFIG REQUIRED)
endif()
set(KF5_DEP_VERSION "5.28.0")
find_package(KF5 ${KF5_DEP_VERSION} REQUIRED COMPONENTS
  Config
  Declarative
  DocTools
  IconThemes
  I18n
  ItemModels
  ItemViews
  JobWidgets
  KCMUtils
  KIO
  NewStuff
  NotifyConfig
  Parts
  Service
  TextEditor
  ThreadWeaver
  XmlGui
  WindowSystem
  Crash
  GuiAddons
  Archive
  Notifications
)
find_package(KF5SysGuard CONFIG)
set_package_properties(KF5SysGuard PROPERTIES
    PURPOSE "Framework for process listing. Required for the 'Attach to Process' feature"
    TYPE RECOMMENDED
)
find_package(KDevelop-PG-Qt 1.90.90 CONFIG)
set_package_properties(KDevelop-PG-Qt PROPERTIES
    PURPOSE "KDevelop parser generator library. Required for the QMake Builder/Manager plugin."
    TYPE RECOMMENDED
)

find_package(SharedMimeInfo REQUIRED)

if(NOT CMAKE_VERSION VERSION_LESS "3.10.0" AND KF5_VERSION VERSION_LESS "5.42.0")
  # CMake 3.9+ warns about automoc on files without Q_OBJECT, and doesn't know about other macros.
  # 3.10+ lets us provide more macro names that require automoc.
  # KF5 >= 5.42 takes care itself of adding its macros in its cmake config files
  list(APPEND CMAKE_AUTOMOC_MACRO_NAMES
       "K_PLUGIN_FACTORY_WITH_JSON" "K_EXPORT_PLASMA_DATAENGINE_WITH_JSON" "K_EXPORT_PLASMA_RUNNER")
endif()
if(NOT CMAKE_VERSION VERSION_LESS "3.9.0" AND KF5_VERSION VERSION_LESS "5.44.0")
    # CMake's automoc needs help to find names of plugin metadata files in case Q_PLUGIN_METADATA
    # is indirectly used via other C++ preprocessor macros
    # 3.9+ lets us provide some filter rule pairs (keyword, regexp) to match the names of such files
    # in the plain text of the sources. See AUTOMOC_DEPEND_FILTERS docs for details.
    list(APPEND CMAKE_AUTOMOC_DEPEND_FILTERS
        "K_PLUGIN_FACTORY_WITH_JSON"
        "[\n^][ \t]*K_PLUGIN_FACTORY_WITH_JSON[ \t\n]*\\([^,]*,[ \t\n]*\"([^\"]+)\""
        "K_EXPORT_PLASMA_DATAENGINE_WITH_JSON"
        "[\n^][ \t]*K_EXPORT_PLASMA_DATAENGINE_WITH_JSON[ \t\n]*\\([^,]*,[^,]*,[ \t\n]*\"([^\"]+)\""
    )
endif()


add_definitions(
    -DQT_DEPRECATED_WARNINGS
    -DQT_DISABLE_DEPRECATED_BEFORE=0x050700
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_STRICT_ITERATORS
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DKF_DISABLE_DEPRECATED_BEFORE_AND_AT=0x051C00
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000
)
if(NOT Qt5_VERSION VERSION_LESS "5.12.0" AND NOT KF5_VERSION VERSION_LESS "5.56.0")
    add_definitions(
        -DQT_NO_FOREACH
    )
endif()

# Turn off missing-field-initializers warning for GCC to avoid noise from false positives with empty {}
# See discussion: https://mail.kde.org/pipermail/kdevelop-devel/2014-February/046910.html
add_compile_flag_if_supported(-Wno-missing-field-initializers)
add_compile_flag_if_supported(-Werror=switch)
add_compile_flag_if_supported(-Werror=undefined-bool-conversion)
add_compile_flag_if_supported(-Werror=tautological-undefined-compare)
add_compile_flag_if_supported(-Werror=implicit-fallthrough)    # Use Q_FALLTHROUGH for false positives.
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-Wdocumentation)
    add_compile_flag_if_supported(-Wcovered-switch-default)
    add_compile_flag_if_supported(-Wunreachable-code-break)
    # This warning is triggered by every call to qCDebug()
    add_compile_flag_if_supported(-Wno-gnu-zero-variadic-macro-arguments)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    add_compile_flag_if_supported(-pedantic)
    add_compile_flag_if_supported(-Wzero-as-null-pointer-constant CXX_ONLY)
endif()
if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    add_compile_flag_if_supported(-Wsuggest-override CXX_ONLY)
endif()

string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER)
if(CMAKE_BUILD_TYPE_TOLOWER MATCHES "debug"
  OR CMAKE_BUILD_TYPE_TOLOWER STREQUAL "")
  set(COMPILER_OPTIMIZATIONS_DISABLED TRUE)
else()
  set(COMPILER_OPTIMIZATIONS_DISABLED FALSE)
endif()

# create config-kdevelop.h
configure_file(config-kdevelop.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-kdevelop.h)
include_directories(${KDevelop_BINARY_DIR}) # for config-kdevelop.h

add_subdirectory(kdevplatform)
add_subdirectory(plugins)

add_subdirectory(pics)
add_subdirectory(app)
add_subdirectory(app_templates)
add_subdirectory(file_templates)
add_subdirectory(shortcuts)
add_subdirectory(doc)
add_subdirectory(share)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevelop")
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevelopConfig.cmake.in"
                                  "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
                                  INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
)
ecm_setup_version(${KDevelop_VERSION_MAJOR}.${KDevelop_VERSION_MINOR}.${KDevelop_VERSION_PATCH}
                  VARIABLE_PREFIX KDEVELOP
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/kdevelop_version.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevelop")
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/KDevelopConfigVersion.cmake"
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install(EXPORT KDevelopTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" NAMESPACE KDev:: FILE KDevelopTargets.cmake)

# kdebugsettings file
install_qt_logging_categories(TYPE APP_PLUGIN)

# CTestCustom.cmake has to be in the CTEST_BINARY_DIR.
# in the KDE build system, this is the same as CMAKE_BINARY_DIR.
configure_file(${CMAKE_SOURCE_DIR}/CTestCustom.cmake ${CMAKE_BINARY_DIR}/CTestCustom.cmake)

install(FILES org.kde.kdevelop.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

# Make it possible to use the po files fetched by the fetch-translations step
ki18n_install(po)

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== app/CMakeLists.txt ===
find_package(KF5Plasma CONFIG)
set_package_properties(KF5Plasma PROPERTIES
    PURPOSE "Plasma libraries for enabling the plasma addons"
    URL "https://www.kde.org"
    TYPE OPTIONAL)
if(KF5Plasma_FOUND)
    add_subdirectory(plasma)
endif()

option(KDEVELOP_SINGLE_APP "Use QtSingleApplication as KDevelop's base" OFF)

set(kdevelop_SRCS  main.cpp kdevideextension.cpp)

declare_qt_logging_category(kdevelop_SRCS
    IDENTIFIER APP
    TYPE APP
)

qt5_add_resources(kdevelop_SRCS kdevelop.qrc)

#TODO: remove CMAKE_CURRENT_SOURCE_DIR prefix when ECM is fixed
set(kdevelop_PNG_ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/16-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/32-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/48-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/64-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/128-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/256-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/512-apps-kdevelop.png
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/1024-apps-kdevelop.png
)
set(kdevelop_SVG_ICONS
    ${CMAKE_CURRENT_SOURCE_DIR}/icons/sc-apps-kdevelop.svg
)
ecm_install_icons(
    ICONS
        ${kdevelop_PNG_ICONS}
        ${kdevelop_SVG_ICONS}
    DESTINATION ${KDE_INSTALL_ICONDIR}
)
ecm_add_app_icon(kdevelop_SRCS
    ICONS ${kdevelop_PNG_ICONS}
)

qt5_add_resources(kdevelop_SRCS kdevelop.qrc)
add_executable(kdevelop ${kdevelop_SRCS} )
target_link_libraries(kdevelop
    KDev::Interfaces
    KDev::Shell
    KDev::Util

    KF5::Declarative
    KF5::Crash

    Qt5::Quick
)
IF(APPLE)
    target_link_libraries(kdevelop "-framework CoreFoundation")
ENDIF()
if(KDEVELOP_SINGLE_APP)
    add_subdirectory(3rdparty/qtsingleapplication)
    target_link_libraries(kdevelop qtsingleapplication)
endif()

install(TARGETS kdevelop ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES kdevelop! DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
configure_file(start-kdevelop.py.in ${CMAKE_CURRENT_BINARY_DIR}/start-kdevelop.py @ONLY)

option(INSTALL_KDEVELOP_LAUNCH_WRAPPER "Install a wrapper script that sets required environment variables. Only useful when installing into a separate prefix" OFF)
if(INSTALL_KDEVELOP_LAUNCH_WRAPPER)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/start-kdevelop.py DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
endif()

if (WIN32)
install(FILES windows/kdevelop-msvc.bat DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)
endif (WIN32)

if (APPLE)
    # the MacOSX bundle display name property (CFBundleDisplayName) is not currently supported by cmake,
    # so has to be set for all targets in this cmake file
    set(MACOSX_BUNDLE_DISPLAY_NAME KDevelop)
    # We provide our own Info.plist to disable AppNap for KDevelop:
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in)
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.KDevelop")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_BUNDLE_NAME "KDevelop")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_DISPLAY_NAME "KDevelop")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_INFO_STRING "The KDevelop Integrated Development Environment")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_LONG_VERSION_STRING "KDevelop ${KDevelop_VERSION_MAJOR}.${KDevelop_VERSION_MINOR}")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_SHORT_VERSION_STRING "${KDevelop_VERSION_MAJOR}.${KDevelop_VERSION_MINOR}")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_BUNDLE_VERSION "${KDevelop_VERSION_MAJOR}.${KDevelop_VERSION_MINOR}")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_ICON_FILE "kdevelop_SRCS.icns")
    set_target_properties(kdevelop PROPERTIES MACOSX_BUNDLE_COPYRIGHT "KDevelop Team")
endif (APPLE)


########### install files ###############

install( PROGRAMS org.kde.kdevelop.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
install( PROGRAMS org.kde.kdevelop_ps.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
install( PROGRAMS org.kde.kdevelop_kdev4.desktop  DESTINATION  ${KDE_INSTALL_APPDIR} )
install( FILES kdevelop.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFY5RCDIR} )
install( FILES kdevelop.xml DESTINATION ${KDE_INSTALL_MIMEDIR} )
update_xdg_mimetypes( ${KDE_INSTALL_MIMEDIR} )

=== kdevplatform/CMakeLists.txt ===
# kdevplatform soversion
# E.g. for KDevelop 5.2.0 => SOVERSION 52 (we only promise ABI compatibility between patch version updates)
set(KDEVPLATFORM_SOVERSION ${KDEVELOP_SOVERSION})

# Increase this to reset incompatible item-repositories.
# Changing KDEVELOP_VERSION automatically resets the itemrepository as well.
set(KDEV_ITEMREPOSITORY_INCREMENT 1)

set(KDevPlatform_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(KDevPlatform_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})

set(CMAKE_MODULE_PATH ${KDevPlatform_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KDevPlatform")

include(KDevPlatformMacros)
include(KDevPlatformMacrosInternal)

find_package(Grantlee5 CONFIG)
set_package_properties(Grantlee5 PROPERTIES
    PURPOSE "Grantlee templating library, needed for file templates"
    URL "http://www.grantlee.org/"
    TYPE REQUIRED)

set(Boost_ADDITIONAL_VERSIONS 1.39.0 1.39)
find_package(Boost 1.35.0)
set_package_properties(Boost PROPERTIES
    PURPOSE "Boost libraries for enabling the classbrowser"
    URL "https://www.boost.org/"
    TYPE REQUIRED)

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/config-kdevplatform.h.cmake
                ${CMAKE_CURRENT_BINARY_DIR}/config-kdevplatform.h )

include_directories(${KDevPlatform_SOURCE_DIR} ${KDevPlatform_BINARY_DIR})

if(BUILD_TESTING)
  set(KDEV_FIND_DEP_QT5TEST "find_dependency(Qt5Test \"${QT_MIN_VERSION}\")")
endif()
configure_package_config_file("${CMAKE_CURRENT_SOURCE_DIR}/KDevPlatformConfig.cmake.in"
                              "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfig.cmake"
                              INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
)

ecm_setup_version(PROJECT
                  VARIABLE_PREFIX KDEVPLATFORM
                  VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kdevplatform_version.h"
                  PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
                  SOVERSION ${KDEVPLATFORM_SOVERSION}
)

add_subdirectory(sublime)
add_subdirectory(interfaces)
add_subdirectory(project)
add_subdirectory(language)
add_subdirectory(shell)
add_subdirectory(util)
add_subdirectory(outputview)
add_subdirectory(vcs)
add_subdirectory(pics)
add_subdirectory(debugger)
add_subdirectory(documentation)
add_subdirectory(serialization)
add_subdirectory(template)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()


install( FILES
        "${KDevPlatform_BINARY_DIR}/kdevplatform_version.h"
        "${KDevPlatform_BINARY_DIR}/config-kdevplatform.h"
        DESTINATION "${KDE_INSTALL_INCLUDEDIR}/kdevplatform" )
install( FILES
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfig.cmake"
        "${KDevPlatform_BINARY_DIR}/KDevPlatformConfigVersion.cmake"
        cmake/modules/KDevPlatformMacros.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}" )
install( EXPORT KDevPlatformTargets
         DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
         NAMESPACE KDev::
         FILE KDevPlatformTargets.cmake )

# kdebugsettings file
install_qt_logging_categories(TYPE LIBRARY)

=== plugins/CMakeLists.txt ===
# BEGIN: Analyzers
add_subdirectory(compileanalyzercommon)
add_subdirectory(clangtidy)
add_subdirectory(clazy)
add_subdirectory(cppcheck)
if(UNIX AND NOT (APPLE OR CYGWIN))
    add_subdirectory(heaptrack)
endif()
# END: Analyzers

# BEGIN: Debuggers
add_subdirectory(debuggercommon)
add_subdirectory(lldb)
add_subdirectory(gdb)
# END: Debuggers

# BEGIN: Documentation
find_package(Qt5Help CONFIG)
set_package_properties(Qt5Help PROPERTIES
    PURPOSE "The Help module for the Qt toolkit, needed for the qthelp plugin"
    URL "https://www.qt.io/"
    TYPE OPTIONAL)
if(Qt5Help_FOUND)
    ecm_optional_add_subdirectory(qthelp)
endif()
ecm_optional_add_subdirectory(manpage)
# END: Documentation

# BEGIN: Formatters
add_subdirectory(astyle)
add_subdirectory(customscript)
# END: Formatters

# BEGIN: Languages
ecm_optional_add_subdirectory(custom-definesandincludes)

# 3rdparty/qtcreator-libs uses QT_CONFIG which was added for 5.8
if(NOT Qt5_VERSION VERSION_LESS "5.8.0")
    ecm_optional_add_subdirectory(qmljs)
else()
    message(WARNING "Will not build QML/JS plugin, needs Qt >= 5.8.0")
endif()

find_package(Clang 6.0)
set(clangSearchHint "")
if (NOT CLANG_FOUND)
    set(clangSearchHint "Please install a package providing libclang. Either pass -DLLVM_ROOT=/path/to/llvm-prefix or install the 'llvm-config' command-line utility for auto-detection.")
endif()
set_package_properties(Clang PROPERTIES
    DESCRIPTION "Clang libraries from the LLVM project. ${clangSearchHint}"
    PURPOSE "Used for KDevelop's C++/C support plugin."
    TYPE REQUIRED
)

if (CLANG_FOUND)
    if (NOT CLANG_CLANG_LIB)
        message(FATAL_ERROR "Could not find the Clang C library: libclang")
    endif()

    add_library(Clang::clang UNKNOWN IMPORTED)
    set_property(TARGET Clang::clang PROPERTY IMPORTED_LOCATION ${CLANG_CLANG_LIB})
    ecm_optional_add_subdirectory(clang)
endif()
# END: Languages

# BEGIN: Project builders
add_subdirectory(makebuilder)
add_subdirectory(ninjabuilder)
ecm_optional_add_subdirectory(cmakebuilder)
if (KDevelop-PG-Qt_FOUND)
    ecm_optional_add_subdirectory(qmakebuilder)
endif()
# END: Project builders

# BEGIN: Project managers
ecm_optional_add_subdirectory(cmake)
ecm_optional_add_subdirectory(custommake)
ecm_optional_add_subdirectory(custom-buildsystem)
add_subdirectory(meson)
if (KDevelop-PG-Qt_FOUND)
    ecm_optional_add_subdirectory(qmakemanager)
endif()
ecm_optional_add_subdirectory(genericprojectmanager)
# END: Project managers

# BEGIN: Runtimes
add_subdirectory(android)
if (UNIX)
    add_subdirectory(docker)
    add_subdirectory(flatpak)
endif()
# END: Runtimes

# BEGIN: VCS
ecm_optional_add_subdirectory(bazaar)
ecm_optional_add_subdirectory(git)
ecm_optional_add_subdirectory(perforce)

find_package(SubversionLibrary)
set_package_properties(SubversionLibrary PROPERTIES
    PURPOSE "Support for Subversion integration"
    URL "https://subversion.apache.org/"
    TYPE OPTIONAL)

if(SubversionLibrary_FOUND)
    ecm_optional_add_subdirectory(subversion)
endif()

add_subdirectory(vcschangesview)
# END: VCS

# BEGIN: Others
add_subdirectory(appwizard)
add_subdirectory(codeutils)
add_subdirectory(contextbrowser)
add_subdirectory(documentswitcher)
add_subdirectory(documentview)
add_subdirectory(execute)
add_subdirectory(executescript)
add_subdirectory(externalscript)
add_subdirectory(filemanager)
add_subdirectory(filetemplates)
add_subdirectory(grepview)
add_subdirectory(openwith)
add_subdirectory(outlineview)
add_subdirectory(patchreview)
add_subdirectory(problemreporter)
add_subdirectory(projectfilter)
add_subdirectory(projectmanagerview)
add_subdirectory(quickopen)
add_subdirectory(sourceformatter)
add_subdirectory(standardoutputview)
add_subdirectory(switchtobuddy)
add_subdirectory(testview)
add_subdirectory(scratchpad)
ecm_optional_add_subdirectory(classbrowser)
ecm_optional_add_subdirectory(executeplasmoid)
ecm_optional_add_subdirectory(ghprovider)
ecm_optional_add_subdirectory(kdeprovider)
ecm_optional_add_subdirectory(konsole)
if (Qt5QuickWidgets_FOUND)
    add_subdirectory(welcomepage)
endif()

find_package(OktetaKastenControllers 0.3.1 CONFIG)
set_package_properties(OktetaKastenControllers PROPERTIES
    PURPOSE "Required for building Okteta KDevelop plugin."
    URL "https://kde.org/"
    TYPE OPTIONAL)
if (OktetaKastenControllers_FOUND)
    find_package(KastenControllers CONFIG)

    set_package_properties(KastenControllers PROPERTIES
        PURPOSE "Required for building Okteta KDevelop plugin."
        URL "https://kde.org/"
        TYPE OPTIONAL)
endif()
if (OktetaKastenControllers_FOUND AND KastenControllers_FOUND)
    add_subdirectory(okteta)
endif()
# END: Others

=== app/plasma/CMakeLists.txt ===
add_subdirectory(dataengine)
add_subdirectory(applet)

find_package(KF5Runner CONFIG)
set_package_properties(KF5Runner PROPERTIES
    PURPOSE "Framework for Plasma runners. For enabling the KDevelop runner"
    URL "https://www.kde.org"
    TYPE OPTIONAL)
if(KF5Runner_FOUND)
    add_subdirectory(runner)
endif()

=== kdevplatform/documentation/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

find_package(Qt5WebEngineWidgets CONFIG)
if(TARGET Qt5::WebEngineWidgets)
    set_package_properties(Qt5WebEngineWidgets PROPERTIES
        PURPOSE "QtWebEngine, for integrated documentation"
        URL "https://qt.io/"
        TYPE REQUIRED)
else()
    find_package(Qt5WebKitWidgets CONFIG)
    set_package_properties(Qt5WebKitWidgets PROPERTIES
        PURPOSE "QtWebKit, for integrated documentation"
        URL "https://qt.io/"
        TYPE REQUIRED)
    set(USE_QTWEBKIT 1)
endif()

set(KDevPlatformDocumentation_LIB_SRCS
    standarddocumentationview.cpp
    documentationfindwidget.cpp
    documentationview.cpp
)

declare_qt_logging_category(KDevPlatformDocumentation_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "documentation"
)

ki18n_wrap_ui(KDevPlatformDocumentation_LIB_SRCS documentationfindwidget.ui)
kdevplatform_add_library(KDevPlatformDocumentation SOURCES ${KDevPlatformDocumentation_LIB_SRCS})

target_link_libraries(KDevPlatformDocumentation
PUBLIC
    KDev::Interfaces
PRIVATE
    KDev::Util
)

if(USE_QTWEBKIT)
    target_link_libraries(KDevPlatformDocumentation PRIVATE Qt5::WebKitWidgets)
    target_compile_definitions(KDevPlatformDocumentation PRIVATE -DUSE_QTWEBKIT)
else()
    target_link_libraries(KDevPlatformDocumentation PRIVATE Qt5::WebEngineWidgets)
endif()

install(FILES
    documentationfindwidget.h
    standarddocumentationview.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/documentation COMPONENT Devel
 )

=== kdevplatform/language/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

# Check whether malloc_trim(3) is supported.
include(CheckIncludeFile)
include(CheckSymbolExists)
check_include_file("malloc.h" HAVE_MALLOC_H)
check_symbol_exists(malloc_trim "malloc.h" HAVE_MALLOC_TRIM)

# TODO: fix duchain/stringhelpers.cpp and drop this again
remove_definitions(
    -DQT_NO_CAST_FROM_ASCII
)

if(BUILD_TESTING)
    add_subdirectory(highlighting/tests)
    add_subdirectory(duchain/tests)
    add_subdirectory(backgroundparser/tests)
    add_subdirectory(codegen/tests)
    add_subdirectory(util/tests)
endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/language-features.h.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/language-features.h )

set(KDevPlatformLanguage_LIB_SRCS
    assistant/staticassistantsmanager.cpp
    assistant/renameaction.cpp
    assistant/renameassistant.cpp
    assistant/renamefileaction.cpp
    assistant/staticassistant.cpp

    editor/persistentmovingrangeprivate.cpp
    editor/persistentmovingrange.cpp
    editor/modificationrevisionset.cpp
    editor/modificationrevision.cpp

    backgroundparser/backgroundparser.cpp
    backgroundparser/parsejob.cpp
    backgroundparser/documentchangetracker.cpp
    backgroundparser/parseprojectjob.cpp
    backgroundparser/urlparselock.cpp

    duchain/specializationstore.cpp
    duchain/codemodel.cpp
    duchain/duchain.cpp
    duchain/waitforupdate.cpp
    duchain/duchainpointer.cpp
    duchain/ducontext.cpp
    duchain/indexedducontext.cpp
    duchain/indexedtopducontext.cpp
    duchain/localindexedducontext.cpp
    duchain/indexeddeclaration.cpp
    duchain/localindexeddeclaration.cpp
    duchain/topducontext.cpp
    duchain/topducontextdynamicdata.cpp
    duchain/topducontextutils.cpp
    duchain/functiondefinition.cpp
    duchain/declaration.cpp
    duchain/classmemberdeclaration.cpp
    duchain/classfunctiondeclaration.cpp
    duchain/classdeclaration.cpp
    duchain/use.cpp
    duchain/forwarddeclaration.cpp
    duchain/duchainbase.cpp
    duchain/duchainlock.cpp
    duchain/identifier.cpp
    duchain/parsingenvironment.cpp
    duchain/abstractfunctiondeclaration.cpp
    duchain/functiondeclaration.cpp
    duchain/stringhelpers.cpp
    duchain/namespacealiasdeclaration.cpp
    duchain/aliasdeclaration.cpp
    duchain/dumpdotgraph.cpp
    duchain/duchainutils.cpp
    duchain/declarationid.cpp
    duchain/definitions.cpp
    duchain/uses.cpp
    duchain/importers.cpp
    duchain/duchaindumper.cpp
    duchain/duchainregister.cpp
    duchain/persistentsymboltable.cpp
    duchain/instantiationinformation.cpp
    duchain/problem.cpp

    duchain/types/typesystem.cpp
    duchain/types/typeregister.cpp
    duchain/types/typerepository.cpp
    duchain/types/identifiedtype.cpp
    duchain/types/abstracttype.cpp
    duchain/types/integraltype.cpp
    duchain/types/functiontype.cpp
    duchain/types/structuretype.cpp
    duchain/types/pointertype.cpp
    duchain/types/referencetype.cpp
    duchain/types/delayedtype.cpp
    duchain/types/arraytype.cpp
    duchain/types/indexedtype.cpp
    duchain/types/enumerationtype.cpp
    duchain/types/constantintegraltype.cpp
    duchain/types/enumeratortype.cpp
    duchain/types/typeutils.cpp
    duchain/types/typealiastype.cpp
    duchain/types/unsuretype.cpp
    duchain/types/containertypes.cpp

    duchain/builders/dynamiclanguageexpressionvisitor.cpp

    duchain/navigation/problemnavigationcontext.cpp
    duchain/navigation/abstractnavigationwidget.cpp
    duchain/navigation/abstractnavigationcontext.cpp
    duchain/navigation/usesnavigationcontext.cpp
    duchain/navigation/abstractdeclarationnavigationcontext.cpp
    duchain/navigation/abstractincludenavigationcontext.cpp
    duchain/navigation/useswidget.cpp
    duchain/navigation/usescollector.cpp
    duchain/navigation/quickopenembeddedwidgetcombiner.cpp

    interfaces/abbreviations.cpp
    interfaces/iastcontainer.cpp
    interfaces/ilanguagesupport.cpp
    interfaces/quickopendataprovider.cpp
    interfaces/iquickopen.cpp
    interfaces/editorcontext.cpp
    interfaces/codecontext.cpp
    interfaces/icreateclasshelper.cpp
    interfaces/icontextbrowser.cpp

    codecompletion/codecompletion.cpp
    codecompletion/codecompletionworker.cpp
    codecompletion/codecompletionmodel.cpp
    codecompletion/codecompletionitem.cpp
    codecompletion/codecompletioncontext.cpp
    codecompletion/codecompletionitemgrouper.cpp
    codecompletion/codecompletionhelper.cpp
    codecompletion/normaldeclarationcompletionitem.cpp

    codegen/applychangeswidget.cpp
    codegen/coderepresentation.cpp
    codegen/documentchangeset.cpp
    codegen/duchainchangeset.cpp
    codegen/utilities.cpp
    codegen/codedescription.cpp

    codegen/basicrefactoring.cpp
    codegen/progressdialogs/refactoringdialog.cpp

    util/setrepository.cpp
    util/includeitem.cpp
    util/navigationtooltip.cpp

    highlighting/colorcache.cpp
    highlighting/configurablecolors.cpp
    highlighting/codehighlighting.cpp

    checks/dataaccessrepository.cpp checks/dataaccess.cpp
    checks/controlflowgraph.cpp checks/controlflownode.cpp

    classmodel/classmodel.cpp
    classmodel/classmodelnode.cpp
    classmodel/classmodelnodescontroller.cpp
    classmodel/allclassesfolder.cpp
    classmodel/documentclassesfolder.cpp
    classmodel/projectfolder.cpp

    codegen/templatesmodel.cpp
    codegen/templatepreviewicon.cpp
    codegen/templateclassgenerator.cpp
    codegen/sourcefiletemplate.cpp
    codegen/templaterenderer.cpp
    codegen/templateengine.cpp
    codegen/archivetemplateloader.cpp
)

declare_qt_logging_category(KDevPlatformLanguage_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "language"
)

ki18n_wrap_ui(KDevPlatformLanguage_LIB_SRCS
    codegen/basicrefactoring.ui
    codegen/progressdialogs/refactoringdialog.ui)

kdevplatform_add_library(KDevPlatformLanguage SOURCES ${KDevPlatformLanguage_LIB_SRCS})
target_include_directories(KDevPlatformLanguage PRIVATE ${Boost_INCLUDE_DIRS})
target_link_libraries(KDevPlatformLanguage
PUBLIC
    KDev::Serialization
    KDev::Interfaces
    KDev::Util
    KF5::ThreadWeaver
PRIVATE
    KDev::Project
    KDev::Sublime
    KF5::GuiAddons
    KF5::TextEditor
    KF5::Parts
    KF5::Archive
    KF5::IconThemes
    Grantlee5::Templates
)

install(FILES
    assistant/renameaction.h
    assistant/renameassistant.h
    assistant/staticassistant.h
    assistant/staticassistantsmanager.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/assistant COMPONENT Devel
)

install(FILES
    interfaces/ilanguagesupport.h
    interfaces/icodehighlighting.h
    interfaces/quickopendataprovider.h
    interfaces/quickopenfilter.h
    interfaces/iquickopen.h
    interfaces/codecontext.h
    interfaces/editorcontext.h
    interfaces/iastcontainer.h
    interfaces/icreateclasshelper.h
    interfaces/icontextbrowser.h
    interfaces/abbreviations.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/interfaces COMPONENT Devel
)

install(FILES
    editor/persistentmovingrange.h
    editor/documentrange.h
    editor/documentcursor.h
    editor/cursorinrevision.h
    editor/rangeinrevision.h
    editor/modificationrevision.h
    editor/modificationrevisionset.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/editor COMPONENT Devel
)

install(FILES
    backgroundparser/backgroundparser.h
    backgroundparser/parsejob.h
    backgroundparser/parseprojectjob.h
    backgroundparser/urlparselock.h
    backgroundparser/documentchangetracker.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/backgroundparser COMPONENT Devel
)

install(FILES
    util/navigationtooltip.h
    util/setrepository.h
    util/basicsetrepository.h
    util/includeitem.h
    util/debuglanguageparserhelper.h
    util/kdevhash.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/util COMPONENT Devel
)

install(FILES
    duchain/parsingenvironment.h
    duchain/duchain.h
    duchain/codemodel.h
    duchain/ducontext.h
    duchain/ducontextdata.h
    duchain/topducontext.h
    duchain/topducontextutils.h
    duchain/topducontextdata.h
    duchain/declaration.h
    duchain/declarationdata.h
    duchain/classmemberdeclaration.h
    duchain/classmemberdeclarationdata.h
    duchain/classfunctiondeclaration.h
    duchain/classdeclaration.h
    duchain/functiondefinition.h
    duchain/use.h
    duchain/forwarddeclaration.h
    duchain/duchainbase.h
    duchain/duchainpointer.h
    duchain/duchainlock.h
    duchain/identifier.h
    duchain/abstractfunctiondeclaration.h
    duchain/functiondeclaration.h
    duchain/stringhelpers.h
    duchain/safetycounter.h
    duchain/namespacealiasdeclaration.h
    duchain/aliasdeclaration.h
    duchain/dumpdotgraph.h
    duchain/duchainutils.h
    duchain/duchaindumper.h
    duchain/declarationid.h
    duchain/appendedlist.h
    duchain/duchainregister.h
    duchain/persistentsymboltable.h
    duchain/instantiationinformation.h
    duchain/specializationstore.h
    duchain/indexedducontext.h
    duchain/indexedtopducontext.h
    duchain/localindexedducontext.h
    duchain/indexeddeclaration.h
    duchain/localindexeddeclaration.h
    duchain/definitions.h
    duchain/problem.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/duchain COMPONENT Devel
)

install(FILES
    duchain/types/unsuretype.h
    duchain/types/identifiedtype.h
    duchain/types/typesystem.h
    duchain/types/typeregister.h
    duchain/types/typerepository.h
    duchain/types/typepointer.h
    duchain/types/typesystemdata.h
    duchain/types/abstracttype.h
    duchain/types/integraltype.h
    duchain/types/functiontype.h
    duchain/types/structuretype.h
    duchain/types/pointertype.h
    duchain/types/referencetype.h
    duchain/types/delayedtype.h
    duchain/types/arraytype.h
    duchain/types/indexedtype.h
    duchain/types/enumerationtype.h
    duchain/types/constantintegraltype.h
    duchain/types/enumeratortype.h
    duchain/types/alltypes.h
    duchain/types/typeutils.h
    duchain/types/typealiastype.h
    duchain/types/containertypes.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/duchain/types COMPONENT Devel
)

install(FILES
    duchain/builders/abstractcontextbuilder.h
    duchain/builders/abstractdeclarationbuilder.h
    duchain/builders/abstracttypebuilder.h
    duchain/builders/abstractusebuilder.h
    duchain/builders/dynamiclanguageexpressionvisitor.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/duchain/builders COMPONENT Devel
)

install(FILES
    codecompletion/codecompletion.h
    codecompletion/codecompletionworker.h
    codecompletion/codecompletionmodel.h
    codecompletion/codecompletionitem.h
    codecompletion/codecompletioncontext.h
    codecompletion/codecompletionitemgrouper.h
    codecompletion/codecompletionhelper.h
    codecompletion/normaldeclarationcompletionitem.h
    codecompletion/abstractincludefilecompletionitem.h
    codecompletion/codecompletiontesthelper.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/codecompletion COMPONENT Devel
)

install(FILES
    codegen/applychangeswidget.h
    codegen/astchangeset.h
    codegen/duchainchangeset.h
    codegen/documentchangeset.h
    codegen/coderepresentation.h
    codegen/utilities.h
    codegen/templatesmodel.h
    codegen/templatepreviewicon.h
    codegen/templaterenderer.h
    codegen/templateengine.h
    codegen/sourcefiletemplate.h
    codegen/templateclassgenerator.h
    codegen/codedescription.h
    codegen/basicrefactoring.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/language/codegen COMPONENT Devel
)

install(FILES
    duchain/navigation/usesnavigationcontext.h
    duchain/navigation/abstractnavigationcontext.h
    duchain/navigation/abstractdeclarationnavigationcontext.h
    duchain/navigation/abstractincludenavigationcontext.h
    duchain/navigation/abstractnavigationwidget.h
    duchain/navigation/navigationaction.h
    duchain/navigation/useswidget.h

=== kdevplatform/util/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevplatform\")

########### next target ###############

set(KDevPlatformUtil_LIB_SRCS
    autoorientedsplitter.cpp
    foregroundlock.cpp
    formattinghelpers.cpp
    zoomcontroller.cpp
    kdevstringhandler.cpp
    focusedtreeview.cpp
    processlinemaker.cpp
    commandexecutor.cpp
    environmentselectionwidget.cpp
    environmentselectionmodel.cpp
    environmentprofilelist.cpp
    jobstatus.cpp
    activetooltip.cpp
    executecompositejob.cpp
    shellutils.cpp
    multilevellistview.cpp
    objectlist.cpp
    placeholderitemproxymodel.cpp
    projecttestjob.cpp
    widgetcolorizer.cpp
    path.cpp
    texteditorhelpers.cpp
    stack.cpp
    expandablelineedit.cpp
)

if(NOT WIN32)
    add_subdirectory(dbus_socket_transformer)
endif()

if(BUILD_TESTING)
    add_subdirectory(duchainify) # needs KDev::Tests
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

declare_qt_logging_category(KDevPlatformUtil_LIB_SRCS
    TYPE LIBRARY
    CATEGORY_BASENAME "util"
)

kdevplatform_add_library(KDevPlatformUtil SOURCES ${KDevPlatformUtil_LIB_SRCS})
target_link_libraries(KDevPlatformUtil
PUBLIC
    KDev::Interfaces
PRIVATE
    KF5::ItemModels
    KF5::GuiAddons
)
install( FILES kdevplatform_shell_environment.sh DESTINATION bin PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ)

add_executable(kdev_format_source kdevformatsource.cpp kdevformatfile.cpp)
ecm_mark_nongui_executable(kdev_format_source)
target_link_libraries(kdev_format_source Qt5::Core)
install(TARGETS kdev_format_source DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES .zshrc PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        DESTINATION ${KDE_INSTALL_DATAROOTDIR}/kdevplatform/shellutils/)

########### install files ###############

install( FILES
    autoorientedsplitter.h
    foregroundlock.h
    formattinghelpers.h
    zoomcontroller.h
    kdevstringhandler.h
    ksharedobject.h
    focusedtreeview.h
    activetooltip.h
    processlinemaker.h
    commandexecutor.h
    environmentselectionwidget.h
    environmentprofilelist.h
    jobstatus.h
    pushvalue.h
    kdevvarlengtharray.h
    embeddedfreetree.h
    executecompositejob.h
    convenientfreelist.h
    multilevellistview.h
    objectlist.h
    placeholderitemproxymodel.h
    projecttestjob.h
    widgetcolorizer.h
    path.h
    stack.h
    texteditorhelpers.h
    ${CMAKE_CURRENT_BINARY_DIR}/utilexport.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/kdevplatform/util COMPONENT Devel)

=== plugins/astyle/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevastyle\")

find_package(LibAStyle 3.1)
set_package_properties(LibAStyle PROPERTIES
    DESCRIPTION "Artistic Style library"
    PURPOSE "External library for the astyle plugin"
    URL "http://astyle.sourceforge.net/"
    TYPE RECOMMENDED)

declare_qt_logging_category(kdevastyle_LOG_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_ASTYLE
    CATEGORY_BASENAME "astyle"
)

set(kdevastyle_PART_SRCS
    astyle_plugin.cpp
    astyle_preferences.cpp
    astyle_formatter.cpp
    astyle_stringiterator.cpp
    ${kdevastyle_LOG_SRCS}
)

set(astyle_preferences_UI
    astyle_preferences.ui
)

ki18n_wrap_ui(kdevastyle_PART_SRCS ${astyle_preferences_UI} )
kdevplatform_add_plugin(kdevastyle JSON kdevastyle.json SOURCES ${kdevastyle_PART_SRCS})
target_link_libraries(kdevastyle
    astylelib

    KF5::Parts
    KF5::KIOWidgets
    KF5::TextEditor

    KDev::Interfaces
    KDev::Util)

if(NOT LibAStyle_FOUND)
    add_subdirectory(3rdparty/libastyle)
endif()
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/clangtidy/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevclangtidy\")

find_package(ClangTidy QUIET)
set_package_properties(ClangTidy PROPERTIES
    DESCRIPTION "A clang-based C++ “linter” tool"
    URL "https://clang.llvm.org/extra/clang-tidy/"
    TYPE RUNTIME
)

include_directories(
    ${Boost_INCLUDE_DIRS}
)

declare_qt_logging_category(kdevclangtidy_LOG_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_CLANGTIDY
    CATEGORY_BASENAME "clangtidy"
)

set(kdevclangtidy_PART_SRCS
    ${kdevclangtidy_LOG_SRCS}

    analyzer.cpp
    job.cpp
    plugin.cpp
    checkset.cpp
    checksetselection.cpp
    checksetselectionlock.cpp
    checksetselectionmanager.cpp

    config/clangtidyprojectconfigpage.cpp
    config/clangtidypreferences.cpp
    config/checkselection.cpp
    config/checklistfilterproxysearchline.cpp
    config/checklistitemproxystyle.cpp
    config/checklistmodel.cpp
    config/checkgroup.cpp
    config/checksetselectioncombobox.cpp
    config/checksetselectionlistmodel.cpp
    config/checksetmanagewidget.cpp

    parsers/clangtidyparser.cpp
# disable for now:
# CentOS used for appimage does not have string_ref.hpp (Boost >= 1.53) as used by current code
#     parsers/replacementparser.cpp
)

ki18n_wrap_ui(kdevclangtidy_PART_SRCS
    config/checksetmanagewidget.ui
    config/clangtidypreferences.ui
    config/clangtidyprojectconfigpage.ui
)

qt5_add_resources(kdevclangtidy_PART_SRCS
    kdevclangtidy.qrc
)

kconfig_add_kcfg_files(kdevclangtidy_PART_SRCS
    config/clangtidyconfig.kcfgc
    config/clangtidyprojectconfig.kcfgc
)

kdevplatform_add_plugin(kdevclangtidy
    JSON kdevclangtidy.json
    SOURCES ${kdevclangtidy_PART_SRCS}
)

target_link_libraries(kdevclangtidy
    KDevCompileAnalyzerCommon
    KDev::Interfaces
    KDev::Project
    KDev::Language
    KDev::OutputView
    KDev::Util
    KDev::Shell
    KF5::ItemViews
    KF5::ConfigCore
    KF5::I18n
)
if(Qt5_VERSION VERSION_LESS "5.10.0")
target_link_libraries(kdevclangtidy
    KF5::ItemModels
)
endif()

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/clazy/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevclazy\")

find_package(ClazyStandalone QUIET)
set_package_properties(ClazyStandalone PROPERTIES
    DESCRIPTION "Qt oriented code checker based on clang framework. Krazy's little brother"
    URL "https://cgit.kde.org/clazy.git/about/"
    PURPOSE "Recommended: required by the non-essential Clazy plugin"
    TYPE RUNTIME
)

set(kdevclazy_core_SRCS
    checksdb.cpp
    job.cpp
    jobparameters.cpp
    utils.cpp
    checksetselection.cpp
    checksetselectionlock.cpp
    checksetselectionmanager.cpp
)
declare_qt_logging_category(kdevclazy_core_SRCS
    TYPE PLUGIN
    IDENTIFIER KDEV_CLAZY
    CATEGORY_BASENAME "clazy"
)
kconfig_add_kcfg_files(kdevclazy_core_SRCS GENERATE_MOC
    config/globalsettings.kcfgc
)
kconfig_add_kcfg_files(kdevclazy_core_SRCS
    config/projectsettings.kcfgc
)
add_library(kdevclazy_core STATIC
    ${kdevclazy_core_SRCS}
)
target_link_libraries(kdevclazy_core
    KDevCompileAnalyzerCommon
    KDev::Project
    KDev::Shell
)

set(kdevclazy_SRCS
    analyzer.cpp
    plugin.cpp

    config/checksetselectioncombobox.cpp
    config/checksetselectionlistmodel.cpp
    config/checksetmanagewidget.cpp
    config/checkswidget.cpp
    config/commandlinewidget.cpp
    config/globalconfigpage.cpp
    config/projectconfigpage.cpp
)
ki18n_wrap_ui(kdevclazy_SRCS
    config/checksetmanagewidget.ui
    config/checkswidget.ui
    config/commandlinewidget.ui
    config/globalconfigpage.ui
    config/projectconfigpage.ui
)
qt5_add_resources(kdevclazy_SRCS
    kdevclazy.qrc
)
kdevplatform_add_plugin(kdevclazy
    JSON kdevclazy.json
    SOURCES ${kdevclazy_SRCS}
)
target_link_libraries(kdevclazy
    kdevclazy_core
    KF5::ItemViews
)

ecm_install_icons(ICONS icons/128-apps-clazy.png
                  DESTINATION ${KDE_INSTALL_ICONDIR} THEME hicolor)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()

=== plugins/cmake/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kdevcmake\")
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/parser)

if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
add_subdirectory(icons)

# enable this if you want to have the cmake debug visitor run on each CMakeLists.txt
# the debug visitor prints out the Ast for the CMakeLists.txt file.
#add_definitions( -DCMAKEDEBUGVISITOR )

declare_qt_logging_category(cmake_LOG_SRCS
    TYPE PLUGIN
    IDENTIFIER CMAKE
    CATEGORY_BASENAME "cmake"
)

set( cmakecommon_SRCS
  parser/cmListFileLexer.c
  parser/cmakecachereader.cpp
  parser/cmakelistsparser.cpp
  parser/cmakeduchaintypes.cpp
  cmakeutils.cpp
  cmakeextraargumentshistory.cpp
  cmakebuilddirchooser.cpp
  cmakeserver.cpp
  ${cmake_LOG_SRCS}
)
set_source_files_properties(parser/cmListFileLexer.c PROPERTIES COMPILE_FLAGS "-DYY_NO_INPUT -DYY_NO_UNPUT")

set( cmakecommon_UI
  cmakebuilddirchooser.ui
)

set( cmakemanager_SRCS
  testing/ctestutils.cpp
  testing/ctestfindjob.cpp
  testing/ctestrunjob.cpp
  testing/ctestsuite.cpp
  testing/qttestdelegate.cpp
  cmakeimportjsonjob.cpp
  cmakeserverimportjob.cpp
  cmakenavigationwidget.cpp
  cmakemanager.cpp
  cmakeprojectdata.cpp
  cmakemodelitems.cpp
  duchain/cmakeparsejob.cpp
  duchain/usebuilder.cpp
  duchain/declarationbuilder.cpp
  duchain/contextbuilder.cpp
  cmakecodecompletionmodel.cpp
#   cmakecommitchangesjob.cpp
#   cmakeedit.cpp
  ${cmake_LOG_SRCS}
)

set( cmakemanager_UI
  cmakepossibleroots.ui
)

set( cmakesettings_SRCS
  settings/cmakepreferences.cpp
  settings/cmakecachemodel.cpp
  settings/cmakecachedelegate.cpp
  settings/cmakecachemodel.cpp
)
ki18n_wrap_ui(cmakesettings_SRCS settings/cmakebuildsettings.ui)

set( cmakedoc_SRCS
  cmakedocumentation.cpp
  cmakehelpdocumentation.cpp
  cmakecommandscontents.cpp
)

if(MSVC)
    add_definitions(-DYY_NO_UNISTD_H)
endif()

# Note: This library doesn't follow API/ABI/BC rules and shouldn't have a SOVERSION
#       Its only purpose is to support the plugin without needing to add all source files
#       to the plugin target

kconfig_add_kcfg_files( cmakecommon_SRCS cmakebuilderconfig.kcfgc )
ki18n_wrap_ui( cmakecommon_SRCS ${cmakecommon_UI} )
kdevelop_add_private_library(KDevCMakeCommon SOURCES ${cmakecommon_SRCS})
target_link_libraries(KDevCMakeCommon
    PUBLIC
        KDev::Interfaces
        KDev::Project
        KDev::Util
        KDev::Language
        KF5::TextEditor
)

ki18n_wrap_ui( cmakemanager_SRCS ${cmakemanager_UI} )
add_library( kdevcmakemanagernosettings STATIC ${cmakemanager_SRCS})
target_link_libraries(kdevcmakemanagernosettings
    KDevCMakeCommon
    kdevmakefileresolver
    KDev::Util
    KDev::Interfaces
    KDev::Project
    KDev::Language
    KDev::Sublime
    KDev::OutputView
    KF5::KIOWidgets
    KF5::TextEditor
    Qt5::Concurrent
)

kdevplatform_add_plugin(kdevcmakemanager JSON kdevcmakemanager.json SOURCES ${cmakemanager_SRCS} ${cmakesettings_SRCS})
target_link_libraries(kdevcmakemanager
    KDevCMakeCommon
    kdevmakefileresolver
    KDev::Util
    KDev::Interfaces
    KDev::Project
    KDev::Language
    KDev::Shell
    KDev::OutputView
    KF5::KIOWidgets
    KF5::TextEditor
    Qt5::Concurrent
)

kdevplatform_add_plugin(kdevcmakedocumentation JSON kdevcmakedocumentation.json SOURCES ${cmakedoc_SRCS})
target_link_libraries( kdevcmakedocumentation
    KDevCMakeCommon
    KDev::Interfaces
    KDev::Project
    KDev::Language
    KDev::Documentation
    KDev::Sublime
    KF5::ItemModels
    KF5::TextEditor
)

=== debian/changelog ===
kdevelop (4:5.5.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Pino Toscano <pino@debian.org>  Thu, 13 Feb 2020 21:32:17 +0100

kdevelop (4:5.5.0-1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * Update the build dependencies according to the upstream build system:
    - bump clang, libclang-dev, and llvm-dev to 6.0
  * Rename packages according to the SONAME bumps:
    - kdevelop54-libs -> kdevelop55-libs
  * Update install files.
  * Update lintian overrides.
  * Use an environment variable for the version of plugins, to minimize changes
    to kdevelop.install.

 -- Pino Toscano <pino@debian.org>  Wed, 05 Feb 2020 20:25:48 +0100

kdevelop (4:5.4.6-2) unstable; urgency=medium

  * Team upload.
  * Bump the debhelper compatibility to 12:
    - switch the debhelper build dependency to debhelper-compat 12
    - remove debian/compat
    - drop the dh_makeshlibs override, as -V is done by default
  * Enable all the reprotest variations in the salsa CI.
  * Bump Standards-Version to 4.5.0, no changes required.

 -- Pino Toscano <pino@debian.org>  Tue, 04 Feb 2020 20:24:56 +0100

=== debian/control ===
Source: kdevelop
Section: devel
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>,
           George Kiagiadakis <kiagiadakis.george@gmail.com>,
           Andreas Cord-Landwehr <cola@uni-paderborn.de>
Build-Depends: bash-completion,
               clang (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !powerpcspe !riscv64 !sh4 !x32],
               cmake (>= 2.8.12),
               debhelper-compat (= 12),
               dh-exec,
               extra-cmake-modules (>= 5.59~),
               gettext,
               kdevelop-pg-qt (>= 2.2.0),
               libboost-serialization-dev,
               libastyle-dev (>= 3.1),
               libclang-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !powerpcspe !riscv64 !sh4 !x32],
               libgrantlee5-dev,
               libkf5archive-dev (>= 5.28.0),
               libkf5config-dev (>= 5.28.0),
               libkf5crash-dev (>= 5.28.0),
               libkf5declarative-dev (>= 5.28.0),
               libkf5doctools-dev (>= 5.28.0),
               libkf5guiaddons-dev (>= 5.28.0),
               libkf5i18n-dev (>= 5.28.0),
               libkf5iconthemes-dev (>= 5.28.0),
               libkf5itemmodels-dev (>= 5.28.0),
               libkf5itemviews-dev (>= 5.28.0),
               libkf5jobwidgets-dev (>= 5.28.0),
               libkf5kcmutils-dev (>= 5.28.0),
               libkf5kio-dev (>= 5.28.0),
               libkf5newstuff-dev (>= 5.28.0),
               libkf5notifications-dev (>= 5.28.0),
               libkf5notifyconfig-dev (>= 5.28.0),
               libkf5parts-dev (>= 5.28.0),
               libkf5plasma-dev [linux-any],
               libkf5purpose-dev (>= 5.44.0),
               libkf5runner-dev [linux-any],
               libkf5service-dev (>= 5.28.0),
               libkf5sonnet-dev (>= 5.28.0),
               libkf5sysguard-dev,
               libkf5texteditor-dev (>= 5.28.0),
               libkf5threadweaver-dev (>= 5.28.0),
               libkf5widgetsaddons-dev (>= 5.28.0),
               libkf5windowsystem-dev (>= 5.28.0),
               libkf5xmlgui-dev (>= 5.28.0),
               libkomparediff2-dev,
               libqt5webkit5-dev (>= 5.7.0),
               libsvn-dev,
               llvm-dev (>= 1:6.0) [!alpha !hppa !ia64 !kfreebsd-any !m68k !powerpcspe !riscv64 !sh4 !x32],
               okteta-dev (>= 5:0.26.2~),
               pkg-config,
               pkg-kde-tools (>= 0.15.16),
               qtbase5-dev (>= 5.7.0),
               qtdeclarative5-dev (>= 5.7.0),
               qttools5-dev,
               qttools5-dev-tools,
               shared-mime-info
Standards-Version: 4.5.0
Homepage: https://www.kdevelop.org/
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/kdevelop
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/kdevelop.git

Package: kdevelop55-libs
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared libraries for the KDevelop platform
 This package contains shared libraries needed to run integrated development
 environments based on the KDevelop platform.
 .
 This package is part of the KDevelop platform.

Package: kdevelop
Architecture: any
Depends: kdevelop-data (>= ${source:Version}),
         kdevelop55-libs (= ${binary:Version}),
         kinit,
         qml-module-qtquick-controls,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick-xmllistmodel,
         qml-module-qtquick2,
         qml-module-qtwebkit,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ${kdevelop:clang}, g++, gcc, gdb (>= 7.0), kapptemplate, kio-extras, make
Suggests: clang,
          clang-tidy,
          clazy,
          cmake,
          cppcheck,
          git,
          heaptrack [linux-any],
          kdevelop-l10n,
          konsole,
          meson,
          ninja-build
Breaks: kdevplatform10-libs (<< 5.2)
Replaces: kdevplatform10-libs (<< 5.2)
Description: integrated development environment for C/C++ and other languages
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 KDevelop has parser backends for C, C++ and Javascript/QML, with further
 external plugins supporting e.g. PHP or Python.

Package: kdevelop-data
Architecture: all
Depends: ${misc:Depends}
Breaks: kdevplatform10-libs (<< 5.2)
Replaces: kdevplatform10-libs (<< 5.2)
Description: data files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains arch independent data for KDevelop.

Package: kdevelop-dev
Section: libdevel
Architecture: any
Depends: kdevelop55-libs (= ${binary:Version}),
         libgrantlee5-dev,
         libkf5archive-dev (>= 5.28.0),
         libkf5config-dev (>= 5.28.0),
         libkf5guiaddons-dev (>= 5.28.0),
         libkf5i18n-dev (>= 5.28.0),
         libkf5iconthemes-dev (>= 5.28.0),
         libkf5itemmodels-dev (>= 5.28.0),
         libkf5itemviews-dev (>= 5.28.0),
         libkf5jobwidgets-dev (>= 5.28.0),
         libkf5kcmutils-dev (>= 5.28.0),
         libkf5kio-dev (>= 5.28.0),
         libkf5newstuff-dev (>= 5.28.0),
         libkf5notifications-dev (>= 5.28.0),
         libkf5notifyconfig-dev (>= 5.28.0),
         libkf5parts-dev (>= 5.28.0),
         libkf5service-dev (>= 5.28.0),
         libkf5texteditor-dev (>= 5.28.0),
         libkf5threadweaver-dev (>= 5.28.0),
         libkf5windowsystem-dev (>= 5.28.0),
         qtbase5-dev (>= 5.7.0),
         qtdeclarative5-dev (>= 5.7.0),
         ${misc:Depends}
Breaks: kdevplatform-dev (<< 5.2)
Replaces: kdevplatform-dev (<< 5.2)
Description: development files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains development files for KDevelop.

Package: kdevelop-l10n
Section: localization
Architecture: all
Depends: ${misc:Depends}
Replaces: kdevplatform-l10n (<< 5.2)
Breaks: kdevplatform-l10n (<< 5.2)
Description: localization files for the KDevelop IDE
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the translations for KDevelop.

Package: plasma-kdevelop
Architecture: linux-any
Depends: kdevelop (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: KDevelop plugins for Plasma
 KDevelop is a Free and Open Source integrated development
 environment (IDE). It provides editing, navigation and debugging features for
 several programming languages, as well as integration with multiple build
 systems and version-control systems, using a plugin-based architecture.
 .
 This package contains the KDevelop plugins for integrating in the Plasma
 desktop environment:
  * sessions data engine
  * sessions widget
  * sessions KRunner module

Package: kdevplatform-dev
Section: oldlibs
Architecture: all
Depends: kdevelop-dev (>= ${source:Version}), ${misc:Depends}
Description: transitional package for kdevelop-dev
 This package is a transitional package, to upgrade to kdevelop-dev.
 It can be safely removed after the upgrade.
 .
 This package is part of the KDevelop platform.

Package: kdevplatform-l10n
Section: oldlibs
Architecture: all
Depends: kdevelop-l10n (>= ${source:Version}), ${misc:Depends}
Description: transitional package for kdevelop-l10n
 This package is a transitional package, to upgrade to kdevelop-l10n.
 It can be safely removed after the upgrade.
 .
 This package is part of the KDevelop platform.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

# from the top-level CMakeLists.txt
export KDEV_PLUGIN_VERSION=33

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- -DBUILD_TESTING=OFF

override_dh_install:
	# create this directory if not existing, so kdevelop-data.install
	# is the same, no matter whether clang is built
	mkdir -p debian/tmp/usr/share/kdevclangsupport/
	dh_install

override_dh_missing:
	dh_missing --fail-missing

override_dh_gencontrol:
	dh_gencontrol -- -V'kdevelop:clang=$(shell dpkg -S "$(shell realpath $(shell env PATH=$$(echo "$$PATH" | sed -r -e 's|/usr/lib/ccache/?:||') which clang))" | cut -d: -f1)'

.PHONY: override_dh_auto_test
